<?php
namespace bwdirax_scrollimagereveal_namespace;

use bwdirax_scrollimagereveal_namespace\PageSettings\Page_Settings;
define( "bwdirax_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "bwdirax_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdirax_scrollimagereveal {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdirax_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdirax_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdirax_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdirax_scrollimagereveal_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdirax-reveal-effect-widgets.php' );
	}

	public function bwdirax_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdirax_scrollimagereveal_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdirax-reveal-effect-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdirax_scrollimagereveal_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdirax-scrollimagereveal-category',
			[
				'title' => esc_html__( 'Image Reveal Animation', 'bwdirax-imreeff' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdirax_all_assets_for_the_public(){

		wp_enqueue_script( 'bwdirax-scrollimage-saljs', plugin_dir_url( __FILE__ ) . 'assets/public/js/sal.js', array('jquery'), '1.3', true );

		wp_enqueue_script( 'bwdirax-scrollimagereveal-minjs', plugin_dir_url( __FILE__ ) . 'assets/public/js/jquery.inview.min.js', array('jquery'), '1.3', true );

		wp_enqueue_script( 'bwdirax-scrollimagereveal-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );

		$all_css_file = array(
			'bwdirax-scrollimage-hover-effect-plugin-main' => array('bwdirax-scrollimagereveal_css_path_define'=>bwdirax_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/image-hover-effect.min.css'),
			'bwdirax-scrollimage-sal-plugin-main' => array('bwdirax-scrollimagereveal_css_path_define'=>bwdirax_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/sal.css'),
			'bwdirax-scrollimagereveal-plugin-main' => array('bwdirax-scrollimagereveal_css_path_define'=>bwdirax_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdirax-scrollimagereveal_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdirax_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'bwdirax-scrollimagereveal-admin-main' => array('bwdirax_path_admin_define'=>bwdirax_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdirax_path_admin_define'], null, '1.3', 'all');
        }
	}

	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdirax_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdirax_all_assets_for_elementor_editor_admin']);

		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdirax_scrollimagereveal_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdirax_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdirax_admin_editor_scripts' ] );

		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdirax_scrollimagereveal::instance();